/// <reference path="../typings/index.d.ts" />

import { Injectable, Container } from '../src/DependencyInjection/DependencyInjection';

class Service1 {
    constructor() {
    }

    hello() {
        return true;
    }
}

class Service2 {

    private service1: Service1;

    constructor(dependencies: Array<any>) {
        this.service1 = dependencies[0];
    }

    hello() {
        return this.service1.hello();
    }
}

describe('Register two services and one has a dependency', () => {
    Container.register('Service1', [], new Injectable(Service1.prototype.constructor));
    Container.register('Service2', ['Service1'], new Injectable(Service2.prototype.constructor));

    it('Service2.hello should return true', () => {
        expect(Container.resolve<Service2>('Service2').hello()).toBe(true);
    });

    it('Service1.hello should return true', ()=>{
        expect(Container.resolve<Service1>('Service1').hello()).toBe(true);
    });

    it('Service2.hello should return true', ()=>{
        expect(Container.resolve<Service2>('Service2').hello()).toBe(true);
    });
});